/////////////////////////////////////////////////////////////////
///
///		Title	: XML String Resource Loader Header
///		Copyright (c) 2007, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team	: Desktop Service Development
///
/////////////////////////////////////////////////////////////////
#pragma once

#include "NPCommonUI.h"
#include <atlcoll.h>
#include <atlstr.h>
#include "AbstractResourceLoader.h"

//typedef const LPBYTE	LPCBYTE;
/**
* @ingroup Base Lib
* @brief	String Resource Loader
* @date		01/11/2007
* @author	telltale
* @remark	\n
	xml definition \n
	<?xml version="1.0" encoding="UTF-8" ?> \n
	<resource> \n
		<lang>ko_KR</lang> \n
		<string id="0" value="StringValue"/> \n
	</resource> \n
*/
class NPCOMMONUI_API CNStringResourceLoader : public AbstractResourceLoader
{
public:
	CNStringResourceLoader(void);
	virtual ~CNStringResourceLoader(void);

	///< initialize
	BOOL	Init(CNPUnzipFile*	zipImage);
	///< uninitialize
	BOOL	Close();

	///< get string by number id
	LPCTSTR	GetString(DWORD dwID);
	///< get string by string id
	LPCTSTR GetString(LPCTSTR pszcID);

	BOOL GetStringList(CAtlMap< CString, CString, CStringElementTraits<CString>, CStringElementTraits<CString> >& lstString);
private:
	///< parse xml
	BOOL	_ParseXML(const LPBYTE pBuf);

	///< string map
	CAtlMap< CString, CString, CStringElementTraits<CString>, CStringElementTraits<CString> >	m_mapString;
	///< string lst
	CAtlList<CString> m_lstString;
};
